# data.grandlyon.com Developer Guide

This documentation is fully written in Markdown. [MkDocs](https://www.mkdocs.org/) is used as well, so as to generate a beautiful static site out of this documentation.

## MkDocs configuration

MkDocs can be configured by editing the `mkdocs.yml` file. We refer the user to the [official MkDocs documentation](https://www.mkdocs.org/user-guide/) for futher information.

## Running MkDocs with virtualenv

The following commands allows one to setup a Python virtual environment, capable of running `mkdocs`:

```bash
$ python3 -mvenv venv
$ source venv/bin/activate
$ pip install -r requirements.txt
```

This project can then be built by issuing the following command:

```bash
$ mkdocs build
```

A development server featuring live refresh can be started as follows:

```bash
$ mkdocs serve
```


## Running MkDocs with Docker (recommended)

The provided `Dockerfile` and a `docker-compose.yml` file allow one to build and run this project with Docker.

### Build
```bash
$ docker-compose build
```

### Run
```bash
$ docker-compose up [-d]
```

### Build 'n' Run
```bash
$ docker-compose up --build [-d]
```
