# Resources service

## Features

This service can provide lists of resources and formats.  
A resource is an entity representing some information, usually geographic, that can be accessed by a query (for example Web Map Service) or by downloading a file. One resource can be considered standard (e.g WMS protocol) or not standard (a custom service).  
Each resource is associated with one or many formats.

*Example:*  
the output of a Web Feature Service (WFS), standard service providing an interface for geographical features, is a resource. And it is associated with many formats as such Shapefile or JSON.  

## Dependencies

This service has no dependency on other components.

## Endpoints

The service provides five endpoints,

1. `/resources`;
2. `/resourceformats`;
3. `/projections`;
4. `/formats`;

allowing one to perform CRUD operations in a RESTful manner. Moreover, an healtcheck endpoint is provided,

5. `/health`,

returning a `200` HTTP code if the API is healthy, `503` otherwise. For the service to be healthy, the underlying database must be up.

## Implementation

![resources-service](../../assets/resources-service.png)

The service is implemented using the [NestJS](https://nestjs.com/) framework. We refer the reader to the [NestJS-based micro-services](../../miscellaneous/nestjs-micro-services.md) page for further details concerning NestJS and the features it provides.

Data persistence is achieved by using [PostgreSQL](https://www.postgresql.org/) and [TypeORM](https://github.com/typeorm/typeorm).
